/*
 * DataSummary.hh
 *
 *  Created on: Aug 3, 2012
 *      Author: lamikr
 */

#ifndef DATASUMMARY_HH_
#define DATASUMMARY_HH_

#include <string>

extern "C" {
	#include <uci.h>
	#include <stdbool.h>
}

using namespace std;

enum EnumSummaryPeriod{PERIOD_YEARLY, PERIOD_MONTHLY, PERIOD_DAILY, PERIOD_HOURLY, PERIOD_MINUTELY, PERIOD_SECONDLY};
enum EnumSummaryCalculationType {SUM, DELTA, MIN, MAX, MEAN};

class DataSummary {
	public:
		DataSummary();
		virtual ~DataSummary();
		std::string		device_id;
		static std::string get_summary_period_name(enum EnumSummaryPeriod period_param);
		static std::string get_summary_calculation_name(enum EnumSummaryCalculationType type_param);
};

#endif /* DATASUMMARY_HH_ */
