/*
 * Device.hh
 *
 *  Created on: Mar 4, 2011
 *      Author: lamikr
 */

#ifndef DEVICEINFO_HH_
#define DEVICEINFO_HH_

#include <string>
#include "DeviceConfig.hh"

using namespace std;

namespace plp {
	enum EnumDeviceLifeCycleStatus {LIFECYCLE_STATUS__UNAVAILABLE, LIFECYCLE_STATUS__AVAILABLE};

	class Device {
		public:
			Device(string id_param, string type_param);
			Device(string id_param,
				string type_param,
				string name_param,
				EnumDeviceLifeCycleStatus status_param);
			virtual ~Device() { delete(_cfg); }
			std::string get_id();
			std::string get_name();
			std::string get_type();
			plp::EnumDeviceLifeCycleStatus get_lifecycle_state();
			void set_name(std::string name_param);
			virtual void printout() = 0;
		protected:
			std::string id;
			std::string name;
			std::string type;
			plp::DeviceConfig *_cfg;
			plp::EnumDeviceLifeCycleStatus lifecycle_status;
	};
}

#endif /* DEVICEINFO_HH_ */
