/*
 * DeviceTypeSensor.hh
 *
 *  Created on: Feb 28, 2011
 *      Author: lamikr
 */

#ifndef DEVICETYPESENSOR_HH_
#define DEVICETYPESENSOR_HH_

#include <string>

#include "DataReader.hh"
#include "Device.hh"

using namespace plp;

namespace plp {
	/**
	 * This class defines methods for Device which can return and collect data.
	 */
	class SensorDevice : public Device {
		public:
			SensorDevice(std::string id_param, std::string type_param) : Device(id_param, type_param) {}
			virtual ~SensorDevice() {}
			/*
			 * Returns DataReader class for the device.
			 */
			virtual const DataReader *get_datareader() = 0;
			/**
			 * Returns the unit used by the device data.
			 */
			virtual string get_unit() = 0;
			/*
			 * Returns latest data that is available for the device.
			 */
			virtual plp::Data *get_data() = 0;
	};
}

#endif /* DEVICETYPESENSOR_HH_ */
