/*
 * Store.hh
 *
 *  Created on: Jan 20, 2011
 *      Author: lamikr
 */

#ifndef STORE_HH_
#define STORE_HH_

#include <string>

#include "Data.hh"
#include "Date.hh"
#include "DeviceConfig.hh"

namespace plp {
	class Store {
		public:
			Store(std::string device_id, plp::Date *date_time);
			virtual ~Store();
			virtual plp::DataRange *get_sum(EnumSummaryPeriod period_type_param) = 0;
			virtual plp::DataRange *get_mean(EnumSummaryPeriod period_type_param) = 0;
			virtual plp::DataRange *get_delta(EnumSummaryPeriod period_type_param) = 0;
			virtual plp::DataRange *get_max(EnumSummaryPeriod period_type_param) = 0;
			virtual plp::DataRange *get_min(EnumSummaryPeriod period_type_param) = 0;
		protected:
			std::string	device_id;
			plp::Date	*date;
			plp::DataRange	*store_data;
			plp::DataRange	*range_data;
			bool load(std::string fname_param);
	};
}

#endif /* STORE_HH_ */
